;-----------------------------------------
;   AVI-Demo.asm -- Menu Demonstration
;   based on "C" code by Murray & Pappas
;
;                6/5/2004
;
;   Gene Brennick - pbrennick@verizon.net
;-----------------------------------------
; Demonstrates how to use the MCI interface to read and play back an avi file.
;
; Run the program and select an avi file from the list. It will then play,
; and depending on the audio visual content of the avi file, will play back
; video  and audio content - maybe even with animation ! It is also possible
; to interact with the AVI driver and to change the default window size.
; To do this use the size option in the second drop down menu after playing
; an intial avi file. The selected size remains as the default, even after the
; program has terminated, i.e if you request full screen it will remember next
; time you run the program.
;---------------------------------------
        .386                            ; 32 bit when .386 or better appears before .model
        .model  flat, stdcall
        option  casemap :none
;
; Includes
;---------------------------------------
        include     \masm32\include\windows.inc
        include     \masm32\include\user32.inc
        include     \masm32\include\kernel32.inc
        include     \masm32\include\gdi32.inc
        include     \masm32\include\comdlg32.inc
        include     \masm32\include\winmm.inc
;
; Libraries
;---------------------------------------
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\gdi32.lib
        includelib  \masm32\lib\comdlg32.lib
        includelib  \masm32\lib\winmm.lib
;
; Prototypes
;---------------------------------------
WinMain     PROTO :DWORD, :DWORD, :DWORD, :SDWORD

.data

ID_SELECT_FILE  EQU 40001
ID_SELECT_EXIT  EQU 40002
ID_HELP_ABOUT   EQU 40003
ID_SETSIZE  EQU 40004

Selected    DD  FALSE           ; Set to TRUE once a files been selected
ClassName   db  "SimpleWinClass",0
szAbout     db  "AboutDlgBox",0
szAppName       db  "AVIDemo",0
szInitDir   db  "C:\\",0
szFilterString  db  "AVI",0,"*.avi",0,0 ; Note the double 0
szAVIVideo  db  "AVIVideo",0

buffer      db  80 DUP (?)      ; File name buffer

szProgName  db  'ProgName',0
szConfigure db  'configure',0
szConfigFMT db  'configure %s %s',0
szAVIdrv    db  'MCIavi',0
szCantOpen  db  "Can't open the driver",0

.data?

hInstance HINSTANCE ?
CommandLine LPSTR ?
wDeviceID   DD  ?

LOWORD  MACRO   bigword ;; Retrieves the low word from double word argument

    mov eax,bigword
    and eax,0FFFFh  ;; Set to low word
    ENDM
;----------------------------------------------------------------------------
.code
start:
    invoke GetModuleHandle, NULL
    mov    hInstance,eax
    invoke GetCommandLine
        invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
    invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
    LOCAL wc:WNDCLASSEX, msg:MSG, hwnd:HWND

    mov   wc.lpszClassName, offset szProgName
    mov   wc.cbSize,SIZEOF WNDCLASSEX
    mov   wc.style, CS_HREDRAW or CS_VREDRAW
    mov   wc.lpfnWndProc, OFFSET WndProc
    mov   wc.cbClsExtra,0
    mov   wc.cbWndExtra,0
        push  hInst
        pop   wc.hInstance
    mov   wc.hbrBackground,COLOR_WINDOW+1
    mov   wc.lpszMenuName,offset szAppName
    mov   wc.lpszClassName,OFFSET ClassName
    mov   wc.hIcon,0
        mov   wc.hIconSm,0
        invoke LoadCursor,NULL,IDC_ARROW
    mov   wc.hCursor,eax

        invoke RegisterClassEx, addr wc

        invoke CreateWindowEx, 0,ADDR ClassName,ADDR szAppName,\
           WS_OVERLAPPEDWINDOW,0,0,639,479,NULL,NULL,hInst,NULL
        mov   hwnd,eax

        INVOKE ShowWindow, hwnd,CmdShow
        INVOKE UpdateWindow, hwnd
        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
        .ENDW
        mov     eax,msg.wParam
        ret
WinMain endp

AboutDlgProc    proc    hDlg:DWORD, messg:DWORD, wParam:DWORD, lParam:DWORD

    mov eax, messg

    .IF  eax==WM_INITDIALOG

         mov eax,TRUE
         ret

    .ELSEIF eax==WM_COMMAND

        LOWORD wParam

        .IF eax==IDOK
        invoke  EndDialog, hDlg,0
        mov  eax,TRUE
        ret
        .ENDIF

    .ENDIF

    mov eax,FALSE
    ret

AboutDlgProc    endp

WndProc proc  hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL hMenu:HMENU, hdrv:DWORD

    LOCAL ofn:OPENFILENAME, mciOpenParms:MCI_OPEN_PARMS, mciPlayParms:MCI_PLAY_PARMS
    LOCAL dci:DRVCONFIGINFO

;   Note: Uses Media Control Interface (MCI) to play back AVI files

    mov   eax,uMsg

    .IF eax==WM_COMMAND

        LOWORD  wParam

        .IF  eax==ID_SELECT_FILE

            mov  ofn.lStructSize, sizeof OPENFILENAME
            mov  ofn.hWndOwner,0
            push hInstance
            pop  ofn.hInstance
            mov  ofn.lpstrFilter, OFFSET szFilterString
            mov  ofn.lpstrCustomFilter,0
            mov  ofn.nMaxCustFilter,0
            mov  ofn.nFilterIndex,0
                mov  ofn.lpstrFile, OFFSET buffer   ; Points to buffer holding filename
                mov  ofn.nMaxFile,MAX_PATH
            mov  ofn.lpstrFileTitle,0
            mov  ofn.nMaxFileTitle,0
                mov  ofn.lpstrInitialDir, OFFSET szInitDir
                mov  ofn.lpstrTitle,0
            mov  ofn.Flags,OFN_HIDEREADONLY
            mov  ofn.nFileOffset,0
            mov  ofn.nFileExtension,0
            mov  ofn.lpstrDefExt,0
            mov  ofn.lCustData,0
            mov  ofn.lpfnHook,0
            mov  ofn.lpTemplateName,0

            invoke GetOpenFileName, ADDR ofn    ; Select a file

            .IF  !eax
           mov eax,0
           ret
            .ENDIF

            mov  Selected,TRUE          ; OK, a files been selected

                mov  mciOpenParms.lpstrDeviceType, offset szAVIVideo
            mov  eax,hWnd
                mov  mciOpenParms.dwCallback, eax
            mov  mciOpenParms.lpstrElementName, offset buffer

            invoke mciSendCommand, 0,MCI_OPEN, MCI_OPEN_TYPE or MCI_OPEN_ELEMENT, \
                   ADDR mciOpenParms    ; Returns 0 if successful
            mov  eax,mciOpenParms.wDeviceID     ; Get device ID
            mov  wDeviceID,eax

            invoke mciSendCommand, wDeviceID, MCI_PLAY, MCI_WAIT, ADDR mciPlayParms

            push    eax
            invoke Sleep,1000           ; Wait 1.0 seconds for inspection
            pop     eax

            .IF eax==0
            invoke  mciSendCommand, wDeviceID, MCI_CLOSE, 0, 0 ; Close all ID's
            mov   wDeviceID,eax
            .ENDIF

;       Enable "Size" in Options

                invoke  GetMenu, hWnd
            invoke  GetSubMenu, eax,1       ; Get handle to 2nd popup menu
                invoke  EnableMenuItem, eax, ID_SETSIZE, MF_ENABLED or MF_BYCOMMAND
            invoke  InvalidateRect, hWnd, 0,TRUE

        .ELSEIF eax==ID_SELECT_EXIT

        invoke  SendMessage, hWnd, WM_CLOSE,0,0

        .ELSEIF eax==ID_SETSIZE     ; We only come here after selecting a file

          mov  mciOpenParms.lpstrDeviceType, offset szAVIVideo
          mov  eax,hWnd
              mov  mciOpenParms.dwCallback, eax
          mov  mciOpenParms.lpstrElementName, offset buffer

              invoke mciSendCommand, 0,MCI_OPEN, MCI_OPEN_TYPE or MCI_OPEN_ELEMENT, \
                     ADDR mciOpenParms  ; Returns 0 if successful

          invoke OpenDriver, ADDR szAVIdrv, 0,0 ; Return with driver handle

          .IF   !eax        ; Put out warning msg if can't open driver

          invoke MessageBox, hWnd, ADDR szCantOpen, ADDR szAppName, MB_ICONEXCLAMATION
          .ENDIF

          mov    hdrv,eax

;         See if the driver can be configured

          invoke SendDriverMessage, eax, DRV_QUERYCONFIGURE, 0,0

          mov  dci.dwDCISize, sizeof dci
          mov  dci.lpszDCISectionName,0
          mov  dci.lpszDCIAliasName,0

          .IF eax                   ; Display AVI dialog box
              invoke SendDriverMessage, hdrv, DRV_CONFIGURE, hWnd, ADDR dci
              .ENDIF

          invoke  CloseDriver, hdrv,0,0 ; Close the driver. It should return TRUE
                        ; but returns FALSE instead, otherwise OK

          dec     wDeviceID     ; wDeviceID is equivalent to MCI_ALL_DEVICES_ID
          invoke  mciSendCommand, wDeviceID, MCI_CLOSE, 0, 0 ; Close all ID's

        .ELSEIF eax==ID_HELP_ABOUT

        invoke DialogBoxParam, hInstance, ADDR szAbout, hWnd, ADDR AboutDlgProc,NULL

        .ENDIF

        .ELSEIF eax==WM_DESTROY

          invoke PostQuitMessage,NULL
    .ELSE
              invoke DefWindowProc,hWnd,uMsg,wParam,lParam
              ret
    .ENDIF

        xor    eax,eax
    ret

WndProc endp

        end start

